#lang racket

;;;; 4. cvičenie z predmetu 2-AIN-285 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.10.1
;;;; Dátum: 12.3.2018
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/2-AIN-285-lisp/1718ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - symbolické výrazy,
;;;; - binárne stromy,
;;;; - obecné stromy.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 0
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 0
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0 
;;;; Odovzdať do 18.3.2018 (nedeľa) do 12:00.

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;; (define nil null)

;;; Kapitola. Symbolické výrazy.

;;; Sekcia. Symbolické výrazy.

;; Definícia. Číselný atóm je neprázdny reťazec, ktorý predstavuje korektný
;; zápis takéhoto čísla v niektorej z číselných sústav. Na začiatku môže byť
;; apostrof '.

;; (number? 0)
;; (number? 2018)
;; (number? -1)
;; (number? 1.23)
;; (number? '1)

;; Definícia. Symbolický atóm je neprázdny reťazec, ktorý začína symbolom
;; apostrof '. Číselné atómy, ktoré začínajú apostrofom, nepovažujeme za
;; symbolické atómy.

;; (symbol? 'a)
;; (symbol? 'a1b2c3d4)
;; (symbol? '1A2B3C4D)
;; (symbol? '-=~!@$%^&*_+./<>?)

;;
(not (symbol? '1))
;;
(not (symbol? '()))

;; Špeciálne znaky sa zapisujú špeciálnym spôsobom. Sú to prázdne znaky a tiež
;;   ( ) [ ] { } " , ' ` ; # | \

;; (string->symbol " ")
;; (string->symbol "(")
;; (string->symbol ")")
;; (string->symbol "[")
;; (string->symbol "]")
;; (string->symbol "{")
;; (string->symbol "}")
;; (string->symbol "\"")
;; (string->symbol ",")
;; (string->symbol "'")
;; (string->symbol "`")
;; (string->symbol ";")
;; (string->symbol "#")
;; (string->symbol "|")
;; (string->symbol "\\")

;; Definícia. Atómom rozumieme jednu z týchto možností:
;; - číselný atóm,
;; - symbolický atóm,
;; - konštanta null.

(define (atom? a) (or (number? a) (symbol? a) (null? a)))

;; Definícia. Symbolické výrazy (S-výrazy) sú vytvorené z atómov pomocou
;; operácie párovania (cons).

(define (s-expression? a)
  (or (atom? a)
      (and (pair? a)
           (s-expression? (car a))
           (s-expression? (cdr a)))))

;; (s-expression? 1)
;; (s-expression? 'a)
;; (s-expression? null)
;; (s-expression? (cons 1 'a))
;; (s-expression? (list (list 1 2 3) (list 'a 'b 'c)))

;; Predikát rovnosti na symbolických výrazoch.

;; (and (equal? 1 1) (not (equal? 1 2)))
;; (and (equal? 'a 'a) (not (equal? 'a 'b)))
;; (equal? null '())
;; (and (equal? (cons 1 null) (list 1)) (not (equal? (cons 'a null) (list 'b))))
;; (and (not (equal? 1 'a)) (not (equal? 1 (cons 1 null))) (not (equal? 'a (cons 'a null))))

;;; Sekcia. Špeciálna notácia pre symbolické výrazy.

;; Zápis symbolických výrazov pomocou apostrofu.

;; 'a
;; '()
;; '(1 2 3)
;; '((1 2 3) (4) (5 6))

;; (s-expression? 'a)
;; (s-expression? '())
;; (s-expression? '(1 2 3))
;; (s-expression? '((1 2 3) (4) (5 6)))

;; (equal? 'a 'a)
;; (equal? '() null)
;; (equal? '(1 2 3) (list 1 2 3))
;; (equal? '((1 2 3) (4) (5 6)) (list (list 1 2 3) (list 4) (list 5 6)))

;; Alternatívny zápis pomocou špeciálnej formy quote.

;; (quote a)
;; (quote ())
;; (quote (1 2 3))
;; (quote ((1 2 3) (4) (5 6)))

;; (s-expression? (quote a))
;; (s-expression? (quote ()))
;; (s-expression? (quote (1 2 3)))
;; (s-expression? (quote ((1 2 3) (4) (5 6))))

;; (equal? (quote a) 'a)
;; (equal? (quote ()) null)
;; (equal? (quote (1 2 3)) (list 1 2 3))
;; (equal? (quote ((1 2 3) (4) (5 6))) (list (list 1 2 3) (list 4) (list 5 6)))
