#lang racket

;;;; 4. cvičenie z predmetu 2-AIN-285 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.10.1
;;;; Dátum: 12.3.2018
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/2-AIN-285-lisp/1718ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - symbolické výrazy,
;;;; - binárne stromy,
;;;; - obecné stromy.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 3
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 2
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0
;;;; Odovzdať do 18.3.2018 (nedeľa) do 12:00.

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;; (define nil null)

;;; Kapitola. Stromy.

;;; Sekcia. Binárne stromy.

;; Konštruktory.

;; (define make-empty '())                 ; empty tree
;; (define (make-node x l r) (list x l r)) ; node with left and right subtrees

;; Predikáty.

;; (define (empty? t) (null? t))
;; (define (node? t) (and (list? t) (= (length t) 3)))

;; Selektory.

;; (define (node-data t) (car t))    ; data
;; (define (node-left t) (cadr t))   ; left subtree
;; (define (node-right t) (caddr t)) ; right subtree

;; Binárne stromy.

(define (btree? t)
  (or (null? t)
      (and (list? t)
           (= (length t) 3) 
           (number? (car t))
           (btree? (cadr t))
           (btree? (caddr t)))))

;; (btree? '())
;; (btree? '(1 () ()))
;; (btree? '(1 (2 () ()) (3 () ())))
;; (btree? '(1 (2 (3 () ()) (4 () ())) (5 (6 () ()) (7 () ()))))

;; Úloha. Zostrojte program, ktorý spočíta počet uzlov v strome.

(define (count-nodes t) ...)

;; (count-nodes '())
;; (count-nodes '(1 () ()))
;; (count-nodes '(1 (2 () ()) (3 () ())))
;; (count-nodes '(1 (2 (3 () ()) (4 () ())) (5 (6 () ()) (7 () ()))))

;; Úloha. Zostrojte program, ktorý počíta výšku stromu.

(define (height t) ...)

;; (height '())
;; (height '(1 () ()))
;; (height '(1 (2 () ()) (3 () ())))
;; (height '(1 (2 (3 () ()) (4 () ())) (5 (6 () ()) (7 () ()))))

;; Úloha. Zostrojte program, ktorý vytvorí zrkadlový obraz vstupného stromu.

(define (reflect t) ...)

;; (reflect '())
;; (reflect '(1 () ()))
;; (reflect '(1 (2 () ()) (3 () ())))
;; (reflect '(1 (2 (3 () ()) (4 () ())) (5 (6 () ()) (7 () ()))))
;; (btree? (reflect '(1 (2 (3 () ()) (4 () ())) (5 (6 () ()) (7 () ())))))

;; Úloha. Zostrojte program, ktorý vráti zoznam všetkých uzlov v strome v takom
;; poradi, ktoré odpovedá priamemu prechodu stromom. Nájdite najprv priamočiare
;; riešenie, ktoré využíva operáciu append.

(define (preorder t) ...)

;; (preorder '())
;; (preorder '(1 () ()))
;; (preorder '(1 (2 () ()) (3 () ())))
;; (preorder '(1 (2 (3 () ()) (4 () ())) (5 (6 () ()) (7 () ()))))

;; (1 bod)
;; Úloha. Implementujte predchadzajúci program bez operácie append.

(define (fast-preorder t) ...)

;; (fast-preorder '())
;; (fast-preorder '(1 () ()))
;; (fast-preorder '(1 (2 () ()) (3 () ())))
;; (fast-preorder '(1 (2 (3 () ()) (4 () ())) (5 (6 () ()) (7 () ()))))

;; (2 body)
;; Úloha. Zostrojte program, ktorý nahradí uzly daného stromu číslami 1,2,3,...
;; spôsobom, ktorý odpovedá priamemu prechodu stromom.

(define (preorder-numbering t1) ...)

;; (preorder-numbering '())
;; (preorder-numbering '(10 () ()))
;; (preorder-numbering '(10 (20 () ()) (30 () ())))
;; (preorder-numbering '(10 (20 (30 () ()) (40 () ())) (50 (60 () ()) (70 () ()))))
;; (btree? (preorder-numbering '(10 (20 (30 () ()) (40 () ())) (50 (60 () ()) (70 () ())))))

;; Definícia. Predikát flattened?(t) platí, ak strom t je (doľava) zarovnaný.

(define (flattened? t)
  (or (null? t) (and (null? (caddr t)) (flattened? (cadr t)))))

;; (flattened? '())
;; (flattened? '(1 () ()))
;; (flattened? '(1 (2 () ()) ()))
;; (flattened? '(1 (2 (3 () ()) ()) ()))
;; (not (flattened? '(1 (2 () ()) (3 () ()))))
;; (not (flattened? '(1 (2 (3 () ()) (4 () ())) (5 (6 () ()) (7 () ())))))

;; (prémia 2 body)
;; Úloha. Zostrojte program, ktorý vstupný strom zarovná. Nájdite takú
;; implementáciu, ktorá nepoužíva pomocné funkcie.

(define (flatten t) ...)

;; (flatten '(1 (2 () ()) (3 () ())))
;; (flattened? (flatten '(1 (2 () ()) (3 () ()))))
;; (flatten '(1 (2 (3 () ()) (4 () ())) (5 (6 () ()) (7 () ()))))
;; (flattened? (flatten '(1 (2 (3 () ()) (4 () ())) (5 (6 () ()) (7 () ())))))
