#lang racket

;;;; 4. cvičenie z predmetu 2-AIN-285 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.10.1
;;;; Dátum: 12.3.2018
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/2-AIN-285-lisp/1718ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - symbolické výrazy,
;;;; - binárne stromy,
;;;; - obecné stromy.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 3
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 0
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0 
;;;; Odovzdať do 18.3.2018 (nedeľa) do 12:00.

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;; (define nil null)

;;; Kapitola. Stromy.

;;; Sekcia. Obecné stromy.

;; Konštruktory.

;; (define (make-node x ts) (list* x ts)) ; node with subtrees

;; Predikáty.

;; (define (node? t) (and (list? t) (>= (length t) 1)))

;; Selektory.

;; (define (node-data t) (car t))     ; data
;; (define (node-subtrees t) (cdr t)) ; subtrees

;; Obecné stromy.

(define (tree? t)
  (define (forest? ts)
    (or (null? ts)
        (and (pair? ts)
             (tree? (car ts))
             (forest? (cdr ts)))))
  (and (pair? t)
       (number? (car t))
       (forest? (cdr t))))

;; (tree? '(1))
;; (tree? '(1 (2) (3)))
;; (tree? '(1 (2 (3)) (4 (5) (6) (7)) (8)))

;; Úloha. Zostrojte program, ktorý spočíta počet uzlov v strome.

(define (count-nodes t) ...)

;; (count-nodes '(1))
;; (count-nodes '(1 (2) (3)))
;; (count-nodes '(1 (2 (3)) (4 (5) (6) (7)) (8)))

;; Úloha. Zostrojte program, ktorý počíta výšku (hĺbku) stromu.

(define (height t) ...)

;; (height '(1))
;; (height '(1 (2) (3)))
;; (height '(1 (2 (3)) (4 (5) (6) (7)) (8)))

;; Úloha. Zostrojte program, ktorý vytvorí zrkadlový obraz vstupného stromu.

(define (reflect t) ...)

;; (reflect '(1))
;; (reflect '(1 (2) (3)))
;; (reflect '(1 (2 (3)) (4 (5) (6) (7)) (8)))

;; Úloha. Zostrojte program, ktorý vráti zoznam všetkých uzlov v strome v takom
;; poradi, ktoré odpovedá priamemu prechodu stromom. Nájdite najprv priamočiare
;; riešenie, ktoré využíva operáciu append.

(define (preorder t) ...)

;; (preorder '(1))
;; (preorder '(1 (2) (3)))
;; (preorder '(1 (2 (3)) (4 (5) (6) (7)) (8)))

;; (1 bod)
;; Úloha. Implementujte predchadzajúci program bez operácie append.

(define (fast-preorder t) ...)

;; (fast-preorder '(1))
;; (fast-preorder '(1 (2) (3)))
;; (fast-preorder '(1 (2 (3)) (4 (5) (6) (7)) (8)))

;; (2 body)
;; Úloha. Zostrojte program, ktorý nahradí uzly daného stromu číslami 1,2,3,...
;; spôsobom, ktorý odpovedá priamemu prechodu stromom.

(define (preorder-numbering t1) ...)

;; (preorder-numbering '(2))
;; (preorder-numbering '(2 (3) (5)))
;; (preorder-numbering '(2 (3 (5)) (7 (11) (13) (17)) (19)))
;; (tree? (preorder-numbering '(2 (3 (5)) (7 (11) (13) (17)) (19))))
